"use strict";

var _interopRequireDefault = require("E:/OPU/\u524D\u7AEF\u5F00\u53D1\u9879\u76EE/opu-components-vue/node_modules/@babel/runtime/helpers/interopRequireDefault.js").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.includes.js");

var _objectSpread2 = _interopRequireDefault(require("E:/OPU/\u524D\u7AEF\u5F00\u53D1\u9879\u76EE/opu-components-vue/node_modules/@babel/runtime/helpers/esm/objectSpread2.js"));

var _interface = require("ant-design-vue/lib/date-picker/interface");

var _utils = _interopRequireDefault(require("../../utils"));

var _dateFormat = require("../../utils/dateFormat");

var _moment = _interopRequireDefault(require("moment"));

var _default = {
  name: "OpuDatePicker",
  components: {},
  props: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, (0, _interface.DatePickerProps)()), {}, {
    min: [String, Object],
    max: [String, Object],
    fieldName: {
      type: String,
      default: ""
    },
    inputFormat: {
      type: String,
      default: ""
    },
    formatInputReplace: {
      type: Function,
      default: null
    },
    formatInputBefore: {
      type: Function,
      default: null
    },
    disabledInputDate: {
      type: Boolean,
      default: false
    }
  }),
  model: {
    prop: "value",
    event: "update"
  },
  data: function data() {
    return {
      className: "",
      inputValue: "",
      blocksData: {
        blocks: [],
        datePatterns: [],
        delimiters: []
      }
    };
  },
  computed: {
    componentProps: function componentProps() {
      var _this = this;

      var $listeners = this.$listeners,
          $options = this.$options,
          ok = this.ok;
      var propsData = $options.propsData;
      var ons = {};

      _utils.default.each($listeners, function (cb, type) {
        ons[type] = function () {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this.$emit.apply(_this, [type].concat(args));
        };
      });

      var props = {
        props: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, propsData), {}, {
          dropdownClassName: this.className
        }),
        on: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, ons), {}, {
          change: this.updateValue,
          panelChange: function panelChange(e) {
            if (["year", "month"].includes(propsData.mode)) {
              _this.updateValue(e);
            }
          },
          openChange: this.onOpenChange,
          ok: ok
        })
      };

      if ((this.min || this.max) && !props.props.disabledDate) {
        props.props.disabledDate = function (e) {
          return _this.renderDisabledDate(e);
        };
      }

      return props;
    },
    currentFormat: function currentFormat() {
      var format = "YYYY-MM-DD";

      if (this.componentProps.props && this.componentProps.props.format) {
        format = this.componentProps.props.format;
      } else if (this.componentProps.props && this.componentProps.props.showTime) {
        format = format + " HH:mm:ss";
      }

      return format;
    }
  },
  watch: {
    currentFormat: function currentFormat() {
      this.blocksData = (0, _dateFormat.getBlocks)(this.inputFormat || this.currentFormat);
    },
    fieldName: function fieldName() {
      this.className = "id" + this.fieldName + _utils.default.getUid();
    }
  },
  created: function created() {
    this.className = "id" + this.fieldName + _utils.default.getUid();
    this.blocksData = (0, _dateFormat.getBlocks)(this.inputFormat || this.currentFormat);
    this.focus = _utils.default.throttle(function () {
      this.onFocus();
    }, 100);
  },
  methods: {
    updateValue: function updateValue(value) {
      this.inputValue = value && value.format ? value.format(this.currentFormat) : "";
      this.$emit("update", value);
      this.$emit("change", value);
    },
    onFocus: function onFocus() {
      var input = this.$refs.inputComponent;
      var el = input.$el; // datePicker 获得焦点，弹出选择面板并全选输入框的值

      var box = el.getElementsByClassName("ant-calendar-picker-input");

      if (box && box.length) {
        var boxDom = box[box.length - 1];
        boxDom.click();
      }

      this.onInputEvent();
    },
    ok: function ok() {
      var val = (0, _dateFormat.mergeInputDate)(this.inputValue, this.value.format(this.currentFormat), this.currentFormat);
      var newVal = (0, _moment.default)(val, this.currentFormat);

      if (newVal.format(this.currentFormat) !== "Invalid date") {
        this.updateValue(newVal);
      }
    },
    // 监听输入事件
    onInputEvent: function onInputEvent() {
      var that = this;

      if (!that.disabledInputDate) {
        setTimeout(function () {
          var input = document.querySelector(".".concat(that.className, " .ant-calendar-input"));

          if (input) {
            input.selectionStart = 0; // 选中开始位置

            input.selectionEnd = input.value.length;
            input.removeEventListener("keydown", that.onKeydown);
            input.addEventListener("keydown", that.onKeydown);
            input.removeEventListener("keyup", that.onKeyup);
            input.addEventListener("keyup", that.onKeyup);

            input.oninput = function (e) {
              if (e.inputType !== "deleteContentBackward") {
                if (that.formatInputReplace) {
                  var res = that.formatInputReplace(e);

                  if (res !== false) {
                    e.target.value = res;
                  }
                }

                if (that.formatInputBefore) {
                  var _res = that.formatInputBefore({
                    e: e,
                    format: that.currentFormat,
                    updateValue: that.updateValue,
                    formatInputDate: _dateFormat.formatInputDate,
                    vm: that
                  });

                  if (_res === false) {
                    return;
                  }
                }

                var value = e.target.value;

                if (value) {
                  var newValue = (0, _dateFormat.formatInputDate)(value, that.blocksData);
                  e.target.value = newValue;
                } // if (e.target.value != value) {


                that.inputValue = e.target.value; // }
              }
            };
          }
        }, 100);
      }
    },
    onKeyup: function onKeyup(e) {
      if (e.key === "Enter") {
        e.stopPropagation();
        this.ok();
        this.$emit("inputPressEnter", e);
      }
    },
    onKeydown: function onKeydown(e) {
      e.stopPropagation();
      this.$emit("keydown");
    },
    onOpenChange: function onOpenChange(status) {
      if (status) {
        this.onInputEvent();
      }

      this.$emit("openChange", status);
    },
    renderDisabledDate: function renderDisabledDate(current) {
      if (this.min && current) {
        return current < this.min || this.max && current > this.max;
      } else if (this.min || this.max) {
        return current < this.min || current > this.max.endOf("day");
      }
    }
  },
  render: function render(h) {
    var componentProps = this.componentProps,
        $scopedSlots = this.$scopedSlots,
        value = this.value;
    return h("a-date-picker", {
      ref: "inputComponent",
      props: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, componentProps.props), {}, {
        value: value
      }),
      on: (0, _objectSpread2.default)({}, componentProps.on),
      scopedSlots: $scopedSlots
    }, []);
  }
};
exports.default = _default;