"use strict";

var _interopRequireDefault = require("E:/OPU/\u524D\u7AEF\u5F00\u53D1\u9879\u76EE/opu-components-vue/node_modules/@babel/runtime/helpers/interopRequireDefault.js").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.splice.js");

require("core-js/modules/es.string.fixed.js");

var _babelHelperVueJsxMergeProps = _interopRequireDefault(require("@vue/babel-helper-vue-jsx-merge-props"));

var _objectSpread2 = _interopRequireDefault(require("E:/OPU/\u524D\u7AEF\u5F00\u53D1\u9879\u76EE/opu-components-vue/node_modules/@babel/runtime/helpers/esm/objectSpread2.js"));

var _vue = _interopRequireDefault(require("vue"));

var _utils = _interopRequireDefault(require("../../utils"));

var _sortablejs = _interopRequireDefault(require("sortablejs"));

var _conf = _interopRequireDefault(require("../conf"));

var _modal = require("../../modal");

var _default2 = {
  name: "SetColumns",
  components: {
    Modal: _modal.Modal
  },
  props: {
    option: {
      type: Object,
      default: function _default() {}
    },
    columns: Array,
    defaultColumns: Array
  },
  data: function data() {
    return {
      visible: false,
      tableData: []
    };
  },
  computed: {
    query: function query() {
      var option = this.option;
      return option.proxyConfig && option.proxyConfig.ajax && option.proxyConfig.ajax.query ? option.proxyConfig.ajax.query : null;
    },
    propsConfig: function propsConfig() {
      var option = this.option; // let props = {};
      // if (option.tableConfig.props) {
      // }

      return option.proxyConfig && option.proxyConfig.props ? (0, _objectSpread2.default)((0, _objectSpread2.default)({}, _conf.default.setColumns.proxyConfig.props), option.proxyConfig.props) : _conf.default.setColumns.proxyConfig.props;
    },
    submit: function submit() {
      var option = this.option;
      return option.proxyConfig && option.proxyConfig.ajax && option.proxyConfig.ajax.submit ? option.proxyConfig.ajax.submit : null;
    },
    modalOpt: function modalOpt() {
      var option = this.option;
      return option.modal && option.modal.props ? (0, _objectSpread2.default)((0, _objectSpread2.default)({}, _conf.default.setColumns.modal.props), option.modal.props) : _conf.default.setColumns.modal.props;
    },
    onConfig: function onConfig() {
      var option = this.option;
      return option.proxyConfig && option.proxyConfig.on ? (0, _objectSpread2.default)((0, _objectSpread2.default)({}, _conf.default.setColumns.proxyConfig.on), option.proxyConfig.on) : _conf.default.setColumns.proxyConfig.on;
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this.sortable) {
      this.sortable.destroy();
    }
  },
  methods: {
    show: function show() {
      this.visible = true;
      var query = this.query,
          columns = this.columns,
          handelColumns = this.handelColumns,
          option = this.option;

      if (query || option && option.proxyConfig && option.proxyConfig.params) {
        this.fetchColumns();
      } else {
        this.tableData = handelColumns(_utils.default.clone(columns));
        this.treeDrop();
      }
    },
    handelColumns: function handelColumns(data) {
      var propsConfig = this.propsConfig;
      return this.handleColumnsData(data, propsConfig);
    },
    //处理api获取的表头数据
    handleColumnsData: function handleColumnsData(data, configProps) {
      var _this = this;

      // let copyColumns = utils.clone(columns);
      var apiColumns = data.map(function (item) {
        // 替换字段
        var obj = (0, _objectSpread2.default)({}, item);

        for (var key in configProps) {
          if (key !== "list") {
            obj[key] = item[configProps[key]] || item[configProps[key]] == 0 || item[configProps[key]] === false ? item[configProps[key]] : "";
          }
        }

        if (obj.children && obj.children.length) {
          obj.children = _this.handleColumnsData(obj.children, configProps);
        }

        return obj;
      });
      return apiColumns;
    },
    fetchColumns: function fetchColumns() {
      var _this2 = this;

      var query = this.query,
          propsConfig = this.propsConfig,
          handelColumns = this.handelColumns,
          option = this.option,
          columns = this.columns; // const json = {
      //   ...getOpt.param
      // };

      var defaultAjax = _conf.default.setColumns && _conf.default.setColumns.proxyConfig && _conf.default.setColumns.proxyConfig.defaultAjax ? _conf.default.setColumns.proxyConfig.defaultAjax : {};
      var opt = option.proxyConfig ? option.proxyConfig : {};
      var params = {
        columns: columns
      };
      var queryApi = null;

      if (opt && opt.params) {
        params = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, params), opt.params);

        if (defaultAjax && defaultAjax.query && !query) {
          queryApi = defaultAjax.query;
        }
      }

      if (query) {
        queryApi = query;
      }

      if (!queryApi) {
        this.tableData = handelColumns(_utils.default.clone(columns));
        this.treeDrop();
        return;
      }

      queryApi(params).then(function (res) {
        // const dataField = getOpt.dataField ? getOpt.dataField : "data";
        var data = _utils.default.getObjData(propsConfig.list, res);

        _this2.tableData = handelColumns(data);

        _this2.treeDrop();
      });
    },
    treeDrop: function treeDrop() {
      var _this3 = this;

      this.$nextTick(function () {
        var xTable = _this3.$refs.table;
        _this3.sortable = _sortablejs.default.create(xTable.$el.querySelector(".columns-table .body--wrapper>.vxe-table--body tbody"), {
          handle: ".drag-btn",
          onEnd: function onEnd(_ref) {
            var item = _ref.item,
                oldIndex = _ref.oldIndex;
            var options = {
              children: "children"
            };
            var targetTrElem = item;
            var wrapperElem = targetTrElem.parentNode;
            var prevTrElem = targetTrElem.previousElementSibling;
            var tableTreeData = _this3.tableData;
            var selfRow = xTable.getRowNode(targetTrElem).item;

            var selfNode = _utils.default.findTree(tableTreeData, function (row) {
              return row === selfRow;
            }, options);

            if (prevTrElem) {
              // 移动到节点
              var prevRow = xTable.getRowNode(prevTrElem).item;

              var prevNode = _utils.default.findTree(tableTreeData, function (row) {
                return row === prevRow;
              }, options);

              if (_utils.default.findTree(selfRow[options.children], function (row) {
                return prevRow === row;
              }, options)) {
                // 错误的移动
                var oldTrElem = wrapperElem.children[oldIndex];
                wrapperElem.insertBefore(targetTrElem, oldTrElem);
                return _this3.$XModal.message({
                  message: "不允许自己给自己拖动！",
                  status: "error"
                });
              }

              if (xTable.isTreeExpandByRow(prevRow)) {
                var _currRow = selfNode.items.splice(selfNode.index, 1)[0]; // 移动到当前的子节点

                prevRow[options.children].splice(0, 0, _currRow);
              } else {
                var prevNodeParentKey = prevNode.parent && prevNode.parent._XID ? prevNode.parent._XID : "";
                var selfNodeParentKey = selfNode.parent && selfNode.parent._XID ? selfNode.parent._XID : "";

                if (prevNodeParentKey === selfNodeParentKey) {
                  var _currRow2 = selfNode.items.splice(selfNode.index, 1)[0]; // 移动到相邻节点

                  prevNode.items.splice(prevNode.index + (selfNode.index < prevNode.index ? 0 : 1), 0, _currRow2);
                }
              }
            } else {
              // 移动到第一行
              var currRow = selfNode.items.splice(selfNode.index, 1)[0];
              tableTreeData.unshift(currRow);
            } // 如果变动了树层级，需要刷新数据


            xTable.syncData();
          }
        });
      });
    },
    renderShowEdit: function renderShowEdit(scope) {
      var vm = new _vue.default();
      var h = vm.$createElement;
      return h("a-checkbox", {
        props: {
          checked: scope.row.show
        },
        on: {
          input: function input(checked) {
            scope.row.show = checked;
          }
        }
      });
    },
    getData: function getData() {
      var table = this.$refs.table;
      return table.getTableData();
    },
    onResetColumns: function onResetColumns() {
      var _this4 = this;

      if (this.option.resetColumnsPromise) {
        this.option.resetColumnsPromise(this.tableData).then(function (res) {
          _this4.tableData = _this4.handelColumns(_utils.default.clone(res));
        });
      } else {
        this.tableData = this.handelColumns(_utils.default.clone(this.defaultColumns));
      }
    },
    onCancel: function onCancel() {
      this.visible = false;
    },
    onSubmit: function onSubmit() {
      var _this5 = this;

      var submit = this.submit,
          onConfig = this.onConfig,
          option = this.option;
      var data = this.getData();
      var tableData = data.tableData;
      var opt = option.proxyConfig ? option.proxyConfig : {};
      var params = {};

      if (opt && opt.params) {
        params = opt.params;
      }

      var newTableData = tableData.map(function (item) {
        if (!(item.fixed === "left" || item.fixed === "right")) {
          delete item.fixed;
        }

        return item;
      });
      var defaultAjax = _conf.default.setColumns && _conf.default.setColumns.proxyConfig && _conf.default.setColumns.proxyConfig.defaultAjax ? _conf.default.setColumns.proxyConfig.defaultAjax : {};
      var submitApi = submit;

      if (defaultAjax && defaultAjax.submit && !submitApi) {
        submitApi = defaultAjax.submit;
      }

      var json = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, params), {}, {
        data: newTableData
      });

      if (submitApi) {
        if (onConfig && onConfig.submitBefore) {
          var submitBeforeRes = onConfig.submitBefore(json, opt);

          if (submitBeforeRes === false) {
            return false;
          } else if (submitBeforeRes) {
            json = submitBeforeRes;
          }
        }

        submitApi(json).then(function () {
          _this5.visible = false;

          _this5.$emit("submit");
        });
      } else {
        //转换数据到原来
        var propsConfig = {};

        for (var key in this.propsConfig) {
          propsConfig[this.propsConfig[key]] = key;
        }

        if (onConfig && onConfig.submitBefore) {
          var _submitBeforeRes = onConfig.submitBefore(json);

          if (_submitBeforeRes === false) {
            return;
          }
        }

        this.visible = false;
        this.$emit("submit", newTableData);
      }
    },
    onCellEditChange: function onCellEditChange() {
      if (this.option.tableConfig && this.option.tableConfig.onCellEditChange) {
        var _this$option$tableCon;

        (_this$option$tableCon = this.option.tableConfig).onCellEditChange.apply(_this$option$tableCon, arguments);
      }
    }
  },
  render: function render(h) {
    var _this6 = this;

    var tableData = this.tableData,
        renderShowEdit = this.renderShowEdit,
        modalOpt = this.modalOpt,
        visible = this.visible,
        onSubmit = this.onSubmit,
        onCancel = this.onCancel,
        option = this.option,
        onCellEditChange = this.onCellEditChange;
    var dropBtn = h("span", {
      "class": "drag-btn"
    }, [h("i", {
      "class": "vxe-icon--menu"
    })]);
    var tableColumn = [{
      width: 60,
      align: "center",
      slots: {
        default: "btn_default",
        header: function header() {
          return "排序";
        }
      }
    }, {
      field: "defaultTitle",
      title: "默认标题",
      align: "center",
      minWidth: 100,
      treeNode: true
    }, {
      field: "title",
      title: "显示标题",
      align: "center",
      minWidth: 100,
      itemRender: {
        name: "AInput",
        on: {
          change: onCellEditChange
        }
      }
    }, {
      field: "width",
      title: "列宽",
      align: "center",
      width: 100,
      itemRender: {
        name: "AInputNumber",
        on: {
          change: onCellEditChange
        }
      }
    }, {
      field: "align",
      title: "对齐方式",
      align: "center",
      width: 120,
      itemRender: {
        name: "a-select",
        props: {
          valueField: "value",
          labelField: "label",
          options: [{
            label: "居左",
            value: "left"
          }, {
            label: "居中",
            value: "center"
          }, {
            label: "居右",
            value: "right"
          }]
        },
        on: {
          change: function change(value, option, event) {
            _this6.onCellEditChange(value, event);
          }
        }
      }
    }, {
      field: "show",
      title: "显示",
      align: "center",
      width: 60,
      itemRender: {
        name: "a-checkbox",
        on: {
          change: onCellEditChange
        }
      } // slots: { default: "show_default" }

    }, {
      field: "fixed",
      title: "固定",
      align: "center",
      width: 120,
      itemRender: {
        name: "a-select",
        props: {
          valueField: "value",
          labelField: "label",
          options: [{
            label: "不固定",
            value: ""
          }, {
            label: "靠左",
            value: "left"
          }, {
            label: "靠右",
            value: "right"
          }]
        },
        on: {
          change: onCellEditChange
        }
      }
    }];

    if (option.tableConfig && option.tableConfig.columns) {
      tableColumn = option.tableConfig.columns;
    }

    var modalProps = (0, _objectSpread2.default)({}, modalOpt);
    return h("modal", {
      props: (0, _objectSpread2.default)((0, _objectSpread2.default)({
        title: modalProps.title ? modalProps.title : "设置表头",
        width: 900
      }, modalProps), {}, {
        value: visible
      }),
      on: {
        cancel: onCancel,
        ok: onSubmit
      },
      scopedSlots: {
        footer: function footer() {
          var buttons = [h("a-button", {
            "on": (0, _objectSpread2.default)({}, {
              click: onCancel
            })
          }, ["\u53D6\u6D88"]), h("a-button", {
            "props": (0, _objectSpread2.default)({}, {
              type: "primary"
            }),
            "on": (0, _objectSpread2.default)({}, {
              click: onSubmit
            })
          }, ["\u786E\u5B9A"])];

          if (_this6.option.isShowReset) {
            buttons.push(h("a-button", (0, _babelHelperVueJsxMergeProps.default)([{}, {
              props: {
                type: "primary"
              },
              on: {
                click: _this6.onResetColumns
              },
              style: "float:left;"
            }]), ["\u91CD\u7F6E"]));
          }

          return buttons;
        }
      },
      class: "set-columns-modal"
    }, [h("data-table", {
      class: "columns-table",
      ref: "table",
      props: {
        border: true,
        rowKey: true,
        columns: tableColumn,
        data: tableData,
        treeConfig: {
          children: "children"
        },
        "keyboard-config": {
          isArrow: false
        },
        // editConfig: { trigger: "click", mode: "row" },
        checkboxConfig: {
          checkStrictly: true
        },
        height: "600px",
        transfer: true
      },
      scopedSlots: {
        btn_default: function btn_default() {
          return dropBtn;
        },
        show_default: renderShowEdit
      }
    }, []) //   h(
    //     "SetColums",
    //     {
    //       ref:"setColumsTable",
    //       props:{
    //         option:setColumnsOpt
    //       }
    //     }
    //   )
    ]);
  }
};
exports.default = _default2;